<template>
  <el-dialog
    v-model="props.visible"
    title="消息详情"
    width="750"
    :close-on-click-modal="false"
    :before-close="dialogClose"
  >
    <el-descriptions column="2">
      <el-descriptions-item label="消息标题:">{{ formData.title }}</el-descriptions-item>
      <el-descriptions-item label="消息类型:">{{
        getTyepText(formData.type)
      }}</el-descriptions-item>
      <el-descriptions-item label="业务类型:">{{
        formData.bizType == 1 ? '订单' : '其他'
      }}</el-descriptions-item>
      <el-descriptions-item label="消息状态:">{{
        formData.status == 1 ? '已读' : '未读'
      }}</el-descriptions-item>
      <el-descriptions-item label="消息内容:">{{ formData.content }}</el-descriptions-item>
    </el-descriptions>
    <template #footer>
      <span class="dialog-footer">
        <el-button @click="dialogClose">关闭</el-button>
      </span>
    </template>
  </el-dialog>
</template>
<script lang="ts" setup>
  import { getMessageDetail } from '@/api/dashboard/message';
  import { onMounted, reactive } from 'vue';

  const emit = defineEmits(['success', 'update:visible']);

  /**
   * 定义表单参数
   */
  const formData = reactive({
    id: '',
    title: '',
    type: '',
    bizType: '',
    status: '',
    content: '',
  });

  /**
   * 定义接收的参数
   */
  const props = defineProps({
    visible: {
      type: Boolean,
      required: true,
      default: false,
    },
    messageId: {
      type: Number,
      required: true,
      default: 0,
    },
  });

  /**
   * 关闭弹窗
   */
  const dialogClose = () => {
    emit('update:visible', false);
  };

  /**
   * 设置表单参数
   */
  const setFormData = async () => {
    const data = await getMessageDetail(props.messageId);
    for (const key in formData) {
      if (data[key] != null && data[key] != undefined) {
        //@ts-ignore
        formData[key] = data[key];
      }
    }
  };

  /**
   * 获取类型文本描述
   * @param type 类型
   */
  const getTyepText = (type) => {
    let typeText = '';
    switch (type) {
      case 1:
        typeText = '系统通知';
        break;
      case 2:
        typeText = '用户私信 ';
        break;
      case 3:
        typeText = '代办事项';
        break;
      default:
        break;
    }
    return typeText;
  };

  /**
   * 钩子函数
   */
  onMounted(() => {
    if (props.messageId) {
      setFormData();
    }
  });
</script>
